<template>
  <div class="home">
    <app-header :sticky="true">
      <i
        slot="left"
        class="ic-calendar icon-btn"
        @click="loading ? '' : (showDatePicker = true)"
      />
    </app-header>
    <div class="app-body">
      <div class="main-body">
        <alert-message />
        <loader
          :loading="loading && !$store.state.loading"
          class="home-calendar"
        >
          <section>
            <days-list v-model="date" />
            <div class="home-calendar-body">
              <div class="circles-container">
                <div class="circle text-primary">
                  <span class="text-bold">وزن فعلی</span>
                  <b>{{ plan.weight || '-' }}</b>
                  <small>کیلو گرم</small>
                </div>
                <circle-center
                  :total="plan.goalCalories + plan.actionCalories"
                  :used="plan.foodCalories"
                />
                <div class="circle text-success">
                  <span class="text-bold">وزن هدف</span>
                  <b>{{ plan.goalWeight || '-' }}</b>
                  <small>کیلو گرم</small>
                </div>
              </div>
              <formula
                :total="plan.goalCalories"
                :food="plan.foodCalories"
                :action="plan.actionCalories"
                :remain="plan.remain"
              />
              <div class="boxes">
                <router-link
                  :to="{ name: 'addActivity', query: { date } }"
                  class="variant-primary"
                >
                  <i class="ic-sneaker" />
                  <p>+ فعالیت</p>
                </router-link>
                <router-link
                  :to="{ name: 'addFood', query: { date } }"
                  class="variant-success"
                >
                  <i class="ic-food" />
                  <p>+ خــوراکی</p>
                </router-link>
                <router-link :to="{ name: 'weighing' }" class="variant-warning">
                  <i class="ic-scales" />
                  <p>اعلام وزن</p>
                </router-link>
              </div>
            </div>
          </section>
        </loader>
        <date-picker
          v-model="date"
          element="---"
          :show.sync="showDatePicker"
          @close="showDatePicker = false"
        />
        <div class="mb-4 pt-5">
          <simple-chart
            :options="weightChartData"
            :ratio="9 / 21"
            title="10 وزن اخیر شما"
          />
          <div v-if="hasGoalWeight" class="text-muted font-7 mt-1">
            <i class="ic-alert text-info" />
            <span v-if="user.goalWeight > user.weight">
              هدف شما افزایش وزن میباشد لذا سعی کنید نمودار روند افزایشی داشته
              باشد
            </span>
            <span v-else>
              هدف شما کاهش وزن میباشد لذا سعی کنید نمودار روند کاهشی داشته باشد
            </span>
          </div>
        </div>
        <div class="mb-4">
          <simple-chart
            :options="calorieChartData"
            :ratio="9 / 21"
            colors="#00aaa1"
            title="روند کالری (هفته جاری)"
          />
          <p class="font-7 text-muted mt-1">
            میزان کالری دریافتی شما در طول هفته
          </p>
        </div>
      </div>
    </div>
  </div>
</template>
<script>
import DaysList from './DaysList'
import Formula from './Formula'
import CircleCenter from './CircleCenter'
import AlertMessage from './AlertMessage'
import SimpleChart from '../helper/SimpleChart'
import { mapGetters, mapState } from 'vuex'
let isFirstLoad = true
export default {
  name: 'Home',
  components: { AlertMessage, CircleCenter, DaysList, Formula, SimpleChart },
  data() {
    return {
      loading: false,
      //date: this.$moment().format('YYYY-MM-DD'),
      showDatePicker: false
    }
  },
  syncSettings: ['token'],
  computed: {
    date: {
      get() {
        let date = this.$route.query.date
        if (!date) date = this.$moment().format('YYYY-MM-DD')
        return date
      },
      set(val) {
        let query = { date: val }
        if (val === this.$moment().format('YYYY-MM-DD')) {
          query = {}
        }
        this.$router.replace({ query })
      }
    },
    plan() {
      return this.plans[this.date] || {}
    },
    weightChartData() {
      let data = this.$store.state.home.weightHistory
      let result = {
        labels: [],
        series: [[]]
      }

      data
        .slice(0)
        .reverse()
        .forEach(item => {
          result.labels.push(
            this.$moment(item.createdAt, 'YYYY-MM-DD HH:mm:ss').format('jMM/jD')
          )
          result.series[0].push(item.weight)
        })

      return result
    },
    calorieChartData() {
      let plans = this.plans
      let result = {
        labels: [],
        series: [[]]
      }

      //let now = this.$moment().startOf('day')
      let start = this.$moment().startOf('week')
      let end = start.clone().endOf('week')

      while (start < end) {
        let formatted = start.format('YYYY-MM-DD')
        let data = plans[formatted]
        if (data) {
          result.labels.push(start.format('jMM/jD'))
          result.series[0].push(data.foodCalories)
        }
        start = start.clone().add(1, 'day')
      }
      return result
    },
    ...mapState({ user: state => state.user.data }),
    ...mapGetters({
      hasUserData: 'user/hasData',
      hasGoalWeight: 'user/hasGoalWeight',
      plans: 'home/plans'
    })
  },
  watch: {
    date: {
      handler: 'update',
      immediate: true
    },
    token: 'update'
  },
  created() {
    if (isFirstLoad) {
      // remove the date query from url and show today info
      this.date = this.$moment().format('YYYY-MM-DD')
      isFirstLoad = false
    }
  },
  methods: {
    update() {
      if (!this.$settings.config.token) return
      this.$store.dispatch('home/getDashboard', {
        $force: false,
        $mainLoading: false,
        $vm: this,
        $data: {
          date: this.date
        }
      })
    }
  }
}
</script>
